/****************************************************************************
**
** Copyright (C) 2012 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the QtSql module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this
** file. Please review the following information to ensure the GNU Lesser
** General Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU General
** Public License version 3.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of this
** file. Please review the following information to ensure the GNU General
** Public License version 3.0 requirements will be met:
** http://www.gnu.org/copyleft/gpl.html.
**
** Other Usage
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QSQLRELATIONALTABLEMODELMOD1_P_H
#define QSQLRELATIONALTABLEMODELMOD1_P_H

#include "qsqltablemodel_p.h"
#include "qsqlrelationaltablemodelmod1.h"

QT_BEGIN_HEADER

QT_BEGIN_NAMESPACE

class QSqlRecord;
class QRelationMod1;


class QSqlRelationalTableModelMod1Private: public QSqlTableModelPrivate
{
    Q_DECLARE_PUBLIC(QSqlRelationalTableModelMod1)
public:
    QSqlRelationalTableModelMod1Private()
        : QSqlTableModelPrivate()
    {}

    QString relationField(const QString &tableName, const QString &fieldName) const;

    int nameToIndex(const QString &name) const;

    mutable QVector<QRelationMod1> relations;
    mutable QList<ExColumns> ex_columns;
    //mutable QMap<int,int> relCols;


    QSqlRecord baseRec; // the record without relations
    void clearChanges();
    void clearEditBuffer();
    //void clearCache();
    void revertCachedRow(int row);

    //QSqlRecord editBufferEx;

    void translateFieldNames(int row, QSqlRecord &values) const;
    //QSqlRelationalTableModelMod1::JoinMode joinMode;
};

QT_END_NAMESPACE

QT_END_HEADER

#endif // QSQLRELATIONALTABLEMODELMOD1_P_H
